/**
 * @author Vinay Chhabra
 */

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;

//server implementation
public class CustomServerImpl extends 
				UnicastRemoteObject implements CustomInterface{
	
	//constructor		
	public CustomServerImpl()
					throws RemoteException{
		System.out.println("Creating Server Object");
	}
	
	//remote method used to get a list of products
	public Vector getList()
				throws RemoteException{
		String [] list = {"Computer","Bike","Television","Music system"};
		Vector v = new Vector();
		for(int i=0;i<list.length;i++){
			v.add(list[i]);
		}
		return v;
	}
	
	//remote method used to submit information
	public String submit(Customer cm)
			throws RemoteException{
	  String custName = "Name: ";
	  custName += cm.getName()+"\n";
	  String custAge = "Age: ";
	  custAge += cm.getAge()+"\n";
	  String item = "Item bought: ";
	  item += cm.getItem()+"\n";
	  String custInfo = custName + custAge + item;
	  custInfo+="Thanks for buying.";
	  return custInfo;
	} 
	
	//main method
	public static void main(String args[]){
		try{
			  //Remote object
				CustomInterface obj = new CustomServerImpl();
				
				//bind the specified name to a new remote object. 
				Naming.rebind("Server",	obj);
				System.out.println("Server ready");
		  }catch(Exception ex){
		  	System.out.println("Error: "+ex.getMessage());
		  }
	 }
}