/**
 * @author Vinay Chhabra
 **/

import javax.swing.*;
import java.rmi.*;
import java.awt.*;
import java.awt.event.*;

// Client implementation
public class GreaterClient 
					extends JFrame{
	
	//instance variables
	private JTextField txtOne,txtTwo;
	private JTextArea txtMessage;
	private JLabel lblOne,lblTwo;
	private JButton btnCompare;
	private GreaterInterface obj;
	
	//constructor
	public GreaterClient(){
				
		super("GreaterClient");
	  
	  //method used to create components
    this.createComponents();
    
    //method used to get a remote reference
    this.connect();
    
    //set the default close operation
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    
    //pack() causes this Window to be sized to fit the 
    //preferred size and layouts of its subcomponents. 
    pack();
    
    //show the window
    show();
    
  }	
  
  //method used to create various components
  private void createComponents(){
  	Container cp = getContentPane();
		
		//panels for buttons,textfields. 
		JPanel 
			topPanel = new JPanel(new GridLayout(2,2)),
		  centerPanel= new JPanel(new BorderLayout()),
      btnPanel = new JPanel(new GridLayout(1,1));
    
    //text fields for entering numbers
    txtOne = new JTextField(5);
    txtTwo = new JTextField(5);
    
    lblOne = new JLabel("First Number");
    lblTwo = new JLabel("Second Number");
    
    //text area used to show message
    txtMessage = new JTextArea(7,25);
   
    //button used to compare two numbers
    btnCompare = new JButton("Compare");
    
    //Add an ActionListener to the button.
    btnCompare.addActionListener(new ButtonHandler());
    
    //add the components
    topPanel.add(lblOne);topPanel.add(txtOne);
    topPanel.add(lblTwo);topPanel.add(txtTwo);
    centerPanel.add(txtMessage);
    btnPanel.add(btnCompare);
    
    cp.add(topPanel,BorderLayout.NORTH);
    cp.add(centerPanel);
    cp.add(btnPanel,BorderLayout.SOUTH);

  }
  
  //method used to connect to the server
  private void connect(){
  	try{
  		obj = (GreaterInterface)Naming.lookup("Server");
  	}catch(Exception ex){
  		txtMessage.setText(ex.getMessage());
  	}
  }
 
 //main method  		  
 public static void main(String args[]){
 	 new GreaterClient();
 } 	
 
 //Event handling class
 private class ButtonHandler 
 			implements ActionListener{
 	 public void actionPerformed(ActionEvent ae){
 	  try{
 	  	  //get the value of first text field
 	  	  int one = Integer.parseInt(txtOne.getText());
 	  	  
 	  	  //get the value of second text field
 	  	  int two = Integer.parseInt(txtTwo.getText());
 	  	  
 	  	  //calling the remote method
 	      String msg = obj.getGreater(one,two);	
 	     
 	     //show the value returned by the method
 	     txtMessage.setText(msg);
 	     }catch(Exception ex){
 	     	 txtMessage.setText("Error: " +ex.getMessage());
 	    }
 	      
 	  }
  }
}