/**
 * @author Vinay Chhabra
 **/

import java.rmi.*;
import java.rmi.server.*;
import java.net.MalformedURLException;

//server class
//
public class HelloServerImpl 
	extends UnicastRemoteObject 
						implements HelloInterface{
	
	//constructor
	//	
	public HelloServerImpl()
		throws RemoteException {
					
		System.out.println("Creating server Object");
	}
		
	//remote method called by clients
	//
	public String getMessage()
				throws RemoteException {
			
				return "Hello World";
	}
	
	//main method	
	public static void main(String []helloWorld) {
		try {
			  //create a server object
			  // 
				HelloServerImpl helloServer = new HelloServerImpl();
				
				//bind the server
				//
				Naming.rebind("Server",helloServer);
				System.out.println("Server Ready");
	    }catch(RemoteException ex) {
	   		System.out.println("Error " +ex.getMessage());
	    }
	   catch(MalformedURLException ex) {
	   	 System.out.println("Error " +ex.getMessage());
	   }
 	}    
}
		