/**
 * @author Vinay Chhabra
 **/

import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;

public class Setup {

   // This class registers information about the LazyServerImpl
   // class with rmid and the rmiregistry
    
  public static void main(String[] args) throws Exception {

		//install a security manager
		RMISecurityManager sm = new RMISecurityManager();
		System.setSecurityManager(sm);

    //The first argument
    // to the Properties put method, is 
    // the key and the second is the value 
  	Properties props = new Properties(); 
       props.put("java.security.policy", 
	     "file:/c:/Lazy/policy.txt");

    ActivationGroupDesc agd = new ActivationGroupDesc(props, null);
 	
 	  // Register the ActivationGroupDesc 
 	  // with the activation system to obtain its ID
	  ActivationGroupID agi = 
         ActivationGroup.getSystem().registerGroup(agd);

	  // Now explicitly create the group
		ActivationGroup.createGroup(agi, agd, 0);

	  // The "location" String specifies a URL from where the class   
	  // definition will come when this object is requested.
    //
    String location = "file:/c:/Lazy/";

	  //A MarshalledObject contains a byte stream with the serialized 
	  //representation of an object 
	  MarshalledObject data = null;

	  // Constructs an object descriptor
	  // 
	  ActivationDesc desc = new ActivationDesc 
	     ("LazyServerImpl", location, data);
	
	  // Register with rmid
	  LazyInterface li = (LazyInterface)Activatable.register(desc);
	  System.out.println("Registered");
        
	  // Bind the stub to a name in the registry running on 1099
	  Naming.rebind("LazyServer", li);
	  System.out.println("Exported LazyServerImpl");
  	System.exit(0);
  }

}