/**
 * @author Vinay Chhabra
 */
 
import java.rmi.*;
import java.rmi.registry.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class RegisterClient extends JFrame{

//{{ declare variables //

private RegisterInterface server = null;
private JButton btnList,btnRegister;
private JTextArea txtArea = null;
private JTextField txtName = null;

//constructor //

public RegisterClient(){
	
	super("Register Clients");
	//creating panels //
	JPanel 
		btnPanel = new JPanel(),
	  topPanel = new  JPanel();
	
	
	//components //
		
	JLabel lblTitle = new JLabel("Enter your name");
	txtArea = new JTextArea(12,35);
	txtArea.setEditable(false);
	txtName =  new JTextField(15);
		
	//{{ button related code //
	
	ButtonHandler btnHandler = new ButtonHandler();
	
	btnRegister = new JButton("Register");
	btnRegister.addActionListener(btnHandler);
	
		
	btnList = new JButton("View List");
	btnList.addActionListener(btnHandler);
	

//{{ end of button related code//
  
  // add components
  
  topPanel.add(lblTitle);
  topPanel.add(txtName);

  btnPanel.add(btnRegister);
  btnPanel.add(btnList);
  
  //get a content pane object
  //
  Container cp = getContentPane();
  
  //add the components to the content pane
  //
  cp.add(txtArea,BorderLayout.CENTER);
  cp.add(btnPanel,BorderLayout.SOUTH);
  cp.add(topPanel,BorderLayout.NORTH);
  
  //set the default close operation  
  //
  this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  
  //pack() causes the window to be sized to fit the 
  //preferred size and layouts of its subcomponents. 
  //The Window will be validated after the 
  //preferredSize is calculated.
  //
  pack();
  
  //set the location of window
  //
  setLocation(25,25);
  
  //show the window
	show();
	
	//method used to get a remote reference
	connectServer();
		 	 
}


//{{ event handling class //

private class ButtonHandler 
				implements ActionListener{ 
	public void actionPerformed(ActionEvent ae){
      
      //get the source
      //
      JButton temp = (JButton)ae.getSource();
      
      if(temp ==	btnRegister){
      	try{
      		  String name = txtName.getText().trim(); 
      		  if(!name.equals("")){
      		  	
      		  	//call the remote method to 
      		  	//register the user
      		  	//
      		  	String message = server.register(name);
      			  txtArea.setText(message);
      		   }
      	   }catch(Exception ex){
      				txtArea.setText("Error: "+ex.getMessage());
      	   }
      	 
      }
      else {
      	try{
      		//invoke the remote method to
      		//get the list
      		//
      		String list = server.getList();
      		txtArea.setText(list);
      		}catch(Exception ex){
      				txtArea.setText("Error: "+ex.getMessage());
      	  }
      	  
       }
    }
 }
 //end of event handling class//
 
 private void connectServer(){
 	//get server handle
	try{
		 //Get a reference to the the remote 
		 //object Registry for the local host 
		 //on port number 2000.
     //
	    Registry reg = LocateRegistry.getRegistry(2000);
	    
	    //Get a stub for the 
	    //remote object associated with the 
	    //specified name.
      // 
	    server = (RegisterInterface)reg.lookup("Server");
	    txtArea.setText("Connected");
	   }catch(Exception ex) {
	   	 txtArea.setText("Error: "+ex.getMessage());
	   }
 }
 
 //main method	
 public static void main(String args[]){
 	
 	new RegisterClient();
 }

}