/**
 * @author Vinay Chhabra
 **/

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.rmi.*;

//client implementation
public class ClientServlet 
			extends HttpServlet{
	
	//reference to the remote server
	private ServerHandlerInterface obj;
	
  //Initializes the servlet and logs the initialization.
	public void init(ServletConfig c)
		 throws ServletException{
	
		super.init(c);
	
		try{
		
		//get a remote reference
		obj = (ServerHandlerInterface)Naming.lookup("Server");
		}catch(Exception ex){
			System.out.println("Error: " + ex.getMessage());
		}
	}
	
	//Performs the HTTP GET operation	
	public void doGet(HttpServletRequest req,HttpServletResponse res)
		 throws ServletException,IOException{
		 
		 //get the name of the user
		 String name = req.getParameter("username");
		 String result = null;
		 	try{
		 		// call remote method
		 		result = obj.servletTest(name);
		 	}catch(Exception ex){
		 		result = "Error : " +ex.getMessage();
		 	}
		 
		 //Set the content type for this response object.
		 res.setContentType("text/html");
		 
		 // get a print writer for writing formatted text responses
		 PrintWriter out = res.getWriter();
		 
		 //Print a String and then terminate the line
		 out.println("<Html><Body><H1>RMI AND SERVLETS</H1>");
		 out.println(result+"</Body></Html>");
		
  }
}
		 
				